Date.prototype.toString = function() {
    var year = this.getYear();
    if(year < 2000)
        year += 1900;
    var month = toD2String(this.getMonth() + 1);
    var day = toD2String(this.getDate());
    
    return year + ' / ' + month + ' / ' + day;
}

function toD2String(num)
{
    if(num < 10)
        num = "0" + num;
    return num;
}

/* ------------------------------------------------------------------------------ */

var MESSAGE_ELEMENT_ID = 'message';
function setMessage(message) {
    if($(MESSAGE_ELEMENT_ID).firstChild == null) {
        $(MESSAGE_ELEMENT_ID).appendChild(document.createTextNode(''));
    }
    $(MESSAGE_ELEMENT_ID).firstChild.nodeValue = message;
}

/* ------------------------------------------------------------------------------ */

var LOADING_ELEMENT_ID = 'loading';

function createLoading() {
    var loadingImage = document.createElement('img');
    loadingImage.setAttribute('alt', 'loading...');
    loadingImage.setAttribute('title', 'loading...');
    loadingImage.setAttribute('src', '/img/bar-red.gif');
    $(LOADING_ELEMENT_ID).appendChild(loadingImage);
}

function removeLoading() {
    $(LOADING_ELEMENT_ID).parentNode.removeChild($(LOADING_ELEMENT_ID));
}

function showLoading() {
    $(LOADING_ELEMENT_ID).style.visibility = 'visible';
}

function hideLoading() {
    $(LOADING_ELEMENT_ID).style.visibility = 'hidden';
}

/* ------------------------------------------------------------------------------ */

function clearChilds(node) {
    while(node.lastChild){
        node.removeChild(node.lastChild);
    }
}

function copyNode(source) {
    /*
    ELEMENT_NODE: 1,
    ATTRIBUTE_NODE: 2,
    TEXT_NODE: 3,
    CDATA_SECTION_NODE: 4,
    ENTITY_REFERENCE_NODE: 5,
    ENTITY_NODE: 6,
    PROCESSING_INSTRUCTION_NODE: 7,
    COMMENT_NODE: 8,
    DOCUMENT_NODE: 9,
    DOCUMENT_TYPE_NODE: 10,
    DOCUMENT_FRAGMENT_NODE: 11,
    NOTATION_NODE: 12
    */
    switch(source.nodeType) {
        case Node.ELEMENT_NODE:
            var copy
            copy = document.createElement(source.nodeName);
            copy = copyAttributes(source, copy);
            $A(source.childNodes).each(function(child){
                var copyedNode = copyNode(child);
                copy.appendChild(copyedNode);
            });
            return copy;
        case Node.TEXT_NODE:
            return document.createTextNode(source.nodeValue);
    }
}

function copyAttributes(source, dest) {
    $A(source.attributes).each(function(attribute){
        switch(attribute.nodeName) {
            case 'style':
                dest.style.cssText = attribute.nodeValue;
                break;
            case 'class':
                dest.setAttribute('class', attribute.nodeValue);
                dest.setAttribute('className', attribute.nodeValue);
                break;
            default:
                dest.setAttribute(attribute.nodeName, attribute.nodeValue);
        }
    });
    return dest;
}

/* ------------------------------------------------------------------------------ */

function addEvent(target, eventName, func) {
    Try.these(
        function() { target.addEventListener(eventName, func, false); },
        function() { target.attachEvent('on' + eventName, func); }
    );
}

function removeEvent(target, eventName, func) {
    Try.these(
        function() { target.removeEventListener(eventName, func, false); },
        function() { target.detachEvent('on' + eventName, func); }
    );
}

function getEventSource(e) {
    return e.target ? e.target : e.srcElement;
}

/* ------------------------------------------------------------------------------ */

var Query = Class.create();
Query.prototype = {
    name: null,
    value: null,
    
    initialize: function(name, value) {
        this.name = name;
        this.value = value;
    },
    
    getName: function() { return this.name; },
    getValue: function() { return this.value; }
}

var QueryList = Class.create();
QueryList.prototype = {
    queries: null,
    
    initialize: function(queryArray) {
        this.queries = queryArray;
    },
    
    getValue: function(name) {
        var value = null;
        this.queries.each(function(query){
            if(query.getName() == name && value == null)
                value = query.getValue();
        });
        return value;
    }
}

function getQueryList() {
    var queryString = window.location.search.substring(1);
    if(queryString && 0 < queryString.length) {
        var queries = queryString.split('&');
        if(queries && 0 < queries.length) {
            var queryArray = $A();
            queries.each(function(query){
                nameAndValue = query.split('=');
                var q = new Query(nameAndValue[0], nameAndValue[1]);
                queryArray.push(q);
            });
            return new QueryList(queryArray);
        }
    }
    return null;
}
